﻿using ModelTools.BindingModels;
using ModelTools.Enums;

namespace ModelTools.Interfaces
{
	public interface ISecurityManager
	{
		/// <summary>
		/// Сообщение с причиной не получения доступа
		/// </summary>
		string ErrorMessage { get; set; }

		/// <summary>
		/// Авторизация пользователя к операции
		/// </summary>
		/// <param name="model">Данные по пользователю</param>
		/// <param name="operation">Операция, которую хотят выполнить</param>
		/// <param name="type">Тип операции</param>
		/// <param name="entity">Для какой сущности</param>
		/// <returns></returns>
		bool CheckAccess(AccessBindingModel model, AccessOperation operation, AccessType type, string entity);
	}
}