﻿using ModelTools.Attributes;
using ModelTools.ViewModels;

namespace SecurityBusinessLogic.ViewModels
{
	/// <summary>
	/// Список ролей
	/// </summary>
	public class RoleListViewModel : ListViewModel<RoleViewModel> { }

	/// <summary>
	/// Элемент ролей
	/// </summary>
	public class RoleViewModel : ElementViewModel
	{
		[ViewModelProperty("Название роли", true, true)]
		[MapConfiguration("RoleName")]
		public string RoleName { get; set; }

		[ViewModelProperty("Приоритет", true, true, 100)]
		[MapConfiguration("RolePriority")]
		public int RolePriority { get; set; }

		public override string ToString() => RoleName;
	}
}